/***************************************************************************
                          kttt3d.h  -  description
                             -------------------
    begin                :    8 22:37:07 MSD 2000
    copyright            : (C) 2000 by Andrei Plekhanov
    email                : andyp@newtech.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KTTT3D_H
#define KTTT3D_H

#include <kapp.h>
#include <ktopwidget.h>
#include <kmenubar.h>
#include <kstatusbar.h>
#include <klocale.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qpen.h>

class Ttt3dGame;

class Kttt3d : public KTopLevelWidget
{
  Q_OBJECT

  private:

    static const int MAX_SKILL_ID = 3;

    KMenuBar   * menu;
    KStatusBar * StatusBar;
    KLocale    * locale;
    int          RevertID;
    int          undoID;
    QPopupMenu * edit;
    QPopupMenu * skill;
    Ttt3dGame  * pGame;
    const QPen * pNormalPen;
    const QPen * pBoldPen;
    int          Skill;
    int          SkillIDArr[ MAX_SKILL_ID ];

    virtual void mousePressEvent( QMouseEvent * );

    void GetComputerMove( int Update );

    void ShowOnePos( QPainter * paint,
                     int X_LeftBottom, int Y_LeftBottom,
                     int X_RightBottom, int Y_RightBottom,
                     int X_LeftTop, int Y_LeftTop,
                     int X_RightTop, int Y_RightTop,
                     int Pos ) const;

    void PaintLayer( QPainter * paint, int Number ) const;

    void paintEvent( QPaintEvent * );

    float LinePos( float X1, float X2, float Y1,
                   float Y2, float X_Pos, float Y_Pos ) const;

    int CheckOnePos( int X_LeftBottom, int X_RightBottom,
                     int X_LeftTop, int X_RightTop,
                     int Y_Bottom, int Y_Top,
                     int X_Pos, int Y_Pos ) const;

    int GetMove( int X_Pos, int Y_Pos ) const;

    void ShowHistory( QPainter * paint ) const;

    void SetMove( int Move );

    void UpdateSkillCheched( int Num );

  public slots:

    void NewGame();
    void undo();
    void revert();
    void easy();
    void normal();
    void difficult();
    void about();
    void HowToPlay();

  public:
    /** construtor */
    Kttt3d( void );
    /** destructor */
    ~Kttt3d( void );

    static const int GAP      = 2;
    static const int X_SPACE  = 4;
    static const int Y_SPACE1 = 4;
    static const int Y_SPACE2 = 2;
    static const int X_OFF    = 2;

    static const int X_SHIFT = 7;
    static const int Y_SHIFT = 1;
    static const int X_KOEF  = 10;
    static const int Y_KOEF  = 10;
};
#endif
