/***************************************************************************
                          ticboard.cpp  -  description
                             -------------------
    begin                : Sun Apr 23 2000
    copyright            : (C) 2000 by Andrei Plekhanov
    email                : andyp@newtech.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "ticboard.h"

const int Arr[ 64 ] = { 0, 3, 12, 15, 21, 22, 25, 26, 37, 38, 41, 42, 48, 51, 60, 63,
                        1, 2, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14,
                        16, 17, 18, 19, 20, 23, 24, 27, 28, 29, 30, 31,
                        32, 33, 34, 35, 36, 39, 40, 43, 44, 45, 46, 47,
                        49, 50, 52, 53, 54, 55, 56, 57, 58, 59, 61, 62 };

const int Tab1[ 76 ] = {  0,  4,  8, 12, 16, 20, 24, 28, 32, 36,
                         40, 44, 48, 52, 56, 60,  0,  1,  2,  3,
                         16, 17, 18, 19, 32, 33, 34, 35, 48, 49,
                         50, 51,  0,  1,  2,  3,  4,  5,  6,  7,
                          8,  9, 10, 11, 12, 13, 14, 15,  0, 16,
                         32, 48,  3, 19, 35, 51,  0,  1,  2,  3,
                         12, 13, 14, 15,  0,  4,  8, 12,  3,  7,
                         11, 15,  0,  3, 15, 12 };

const int Tab2[ 76 ] = {  1,  5,  9, 13, 17, 21, 25, 29, 33, 37,
                         41, 45, 49, 53, 57, 61,  4,  5,  6,  7,
                         20, 21, 22, 23, 36, 37, 38, 39, 52, 53,
                         54, 55, 16, 17, 18, 19, 20, 21, 22, 23,
                         24, 25, 26, 27, 28, 29, 30, 31,  5, 21,
                         37, 53,  6, 22, 38, 54, 20, 21, 22, 23,
                         24, 25, 26, 27, 17, 21, 25, 29, 18, 22,
                         26, 30, 21, 22, 26, 25 };

const int Tab3[ 76 ] = {  2,  6, 10, 14, 18, 22, 26, 30, 34, 38,
                         42, 46, 50, 54, 58, 62,  8,  9, 10, 11,
                         24, 25, 26, 27, 40, 41, 42, 43, 56, 57,
                         58, 59, 32, 33, 34, 35, 36, 37, 38, 39,
                         40, 41, 42, 43, 44, 45, 46, 47, 10, 26,
                         42, 58,  9, 25, 41, 57, 40, 41, 42, 43,
                         36, 37, 38, 39, 34, 38, 42, 46, 33, 37,
                         41, 45, 42, 41, 37, 38 };

const int Tab4[ 76 ] = {  3,  7, 11, 15, 19, 23, 27, 31, 35, 39,
                         43, 47, 51, 55, 59, 63, 12, 13, 14, 15,
                         28, 29, 30, 31, 44, 45, 46, 47, 60, 61,
                         62, 63, 48, 49, 50, 51, 52, 53, 54, 55,
                         56, 57, 58, 59, 60, 61, 62, 63, 15, 31,
                         47, 63, 12, 28, 44, 60, 60, 61, 62, 63,
                         48, 49, 50, 51, 51, 55, 59, 63, 48, 52,
                         56, 60, 63, 60, 48, 51 };

ticboard::ticboard( void )
{
  register int i;

  for( i = 0; i < 64; i++ ) {
    Board[ i ] = EMPTY;
  }

  for( i = 0; i < 76; i++ ) {
    Line[ i ] = 0;
  }
}

ticboard::~ticboard( void )
{
}

int ticboard::Check( int Move, int type ) const
{
  switch( Move ) {
    case 0:
      if( Line[ 0 ] == type )
        return( 0 );
      if( Line[ 16 ] == type )
        return( 16 );
      if( Line[ 32 ] == type )
        return( 32 );
      if( Line[ 48 ] == type )
        return( 48 );
      if( Line[ 56 ] == type )
        return( 56 );
      if( Line[ 64 ] == type )
        return( 64 );
      if( Line[ 72 ] == type )
        return( 72 );
    break;
    case 1:
      if( Line[ 0 ] == type )
        return( 0 );
      if( Line[ 17 ] == type )
        return( 17 );
      if( Line[ 33 ] == type )
        return( 33 );
      if( Line[ 57 ] == type )
        return( 57 );
    break;
    case 2:
      if( Line[ 0 ] == type )
        return( 0 );
      if( Line[ 18 ] == type )
        return( 18 );
      if( Line[ 34 ] == type )
        return( 34 );
      if( Line[ 58 ] == type )
        return( 58 );
    break;
    case 3:
      if( Line[ 0 ] == type )
        return( 0 );
      if( Line[ 19 ] == type )
        return( 19 );
      if( Line[ 35 ] == type )
        return( 35 );
      if( Line[ 52 ] == type )
        return( 52 );
      if( Line[ 59 ] == type )
        return( 59 );
      if( Line[ 68 ] == type )
        return( 68 );
      if( Line[ 73 ] == type )
        return( 73 );
    break;

    case 4:
      if( Line[ 1 ] == type )
        return( 1 );
      if( Line[ 16 ] == type )
        return( 16 );
      if( Line[ 36 ] == type )
        return( 36 );
      if( Line[ 65 ] == type )
        return( 65 );
    break;
    case 5:
      if( Line[ 1 ] == type )
        return( 1 );
      if( Line[ 17 ] == type )
        return( 17 );
      if( Line[ 37 ] == type )
        return( 37 );
      if( Line[ 48 ] == type )
        return( 48 );
    break;
    case 6:
      if( Line[ 1 ] == type )
        return( 1 );
      if( Line[ 18 ] == type )
        return( 18 );
      if( Line[ 38 ] == type )
        return( 38 );
      if( Line[ 52 ] == type )
        return( 52 );
    break;
    case 7:
      if( Line[ 1 ] == type )
        return( 1 );
      if( Line[ 19 ] == type )
        return( 19 );
      if( Line[ 39 ] == type )
        return( 39 );
      if( Line[ 69 ] == type )
        return( 69 );
    break;

    case 8:
      if( Line[ 2 ] == type )
        return( 2 );
      if( Line[ 16 ] == type )
        return( 16 );
      if( Line[ 40 ] == type )
        return( 40 );
      if( Line[ 66 ] == type )
        return( 66 );
    break;
    case 9:
      if( Line[ 2 ] == type )
        return( 2 );
      if( Line[ 17 ] == type )
        return( 17 );
      if( Line[ 41 ] == type )
        return( 41 );
      if( Line[ 52 ] == type )
        return( 52 );
    break;
    case 10:
      if( Line[ 2 ] == type )
        return( 2 );
      if( Line[ 18 ] == type )
        return( 18 );
      if( Line[ 42 ] == type )
        return( 42 );
      if( Line[ 48 ] == type )
        return( 48 );
    break;
    case 11:
      if( Line[ 2 ] == type )
        return( 2 );
      if( Line[ 19 ] == type )
        return( 19 );
      if( Line[ 43 ] == type )
        return( 43 );
      if( Line[ 70 ] == type )
        return( 70 );
    break;

    case 12:
      if( Line[ 3 ] == type )
        return( 3 );
      if( Line[ 16 ] == type )
        return( 16 );
      if( Line[ 44 ] == type )
        return( 44 );
      if( Line[ 52 ] == type )
        return( 52 );
      if( Line[ 60 ] == type )
        return( 60 );
      if( Line[ 67 ] == type )
        return( 67 );
      if( Line[ 75 ] == type )
        return( 75 );
    break;
    case 13:
      if( Line[ 3 ] == type )
        return( 3 );
      if( Line[ 17 ] == type )
        return( 17 );
      if( Line[ 45 ] == type )
        return( 45 );
      if( Line[ 61 ] == type )
        return( 61 );
    break;
    case 14:
      if( Line[ 3 ] == type )
        return( 3 );
      if( Line[ 18 ] == type )
        return( 18 );
      if( Line[ 46 ] == type )
        return( 46 );
      if( Line[ 62 ] == type )
        return( 62 );
    break;
    case 15:
      if( Line[ 3 ] == type )
        return( 3 );
      if( Line[ 19 ] == type )
        return( 19 );
      if( Line[ 47 ] == type )
        return( 47 );
      if( Line[ 48 ] == type )
        return( 48 );
      if( Line[ 63 ] == type )
        return( 63 );
      if( Line[ 71 ] == type )
        return( 71 );
      if( Line[ 74 ] == type )
        return( 74 );
    break;


    case 16:
      if( Line[ 4 ] == type )
        return( 4 );
      if( Line[ 20 ] == type )
        return( 20 );
      if( Line[ 32 ] == type )
        return( 32 );
      if( Line[ 49 ] == type )
        return( 49 );
    break;
    case 17:
      if( Line[ 4 ] == type )
        return( 4 );
      if( Line[ 21 ] == type )
        return( 21 );
      if( Line[ 33 ] == type )
        return( 33 );
      if( Line[ 64 ] == type )
        return( 64 );
    break;
    case 18:
      if( Line[ 4 ] == type )
        return( 4 );
      if( Line[ 22 ] == type )
        return( 22 );
      if( Line[ 34 ] == type )
        return( 34 );
      if( Line[ 68 ] == type )
        return( 68 );
    break;
    case 19:
      if( Line[ 4 ] == type )
        return( 4 );
      if( Line[ 23 ] == type )
        return( 23 );
      if( Line[ 35 ] == type )
        return( 35 );
      if( Line[ 53 ] == type )
        return( 53 );
    break;

    case 20:
      if( Line[ 5 ] == type )
        return( 5 );
      if( Line[ 20 ] == type )
        return( 20 );
      if( Line[ 36 ] == type )
        return( 36 );
      if( Line[ 56 ] == type )
        return( 56 );
    break;
    case 21:
      if( Line[ 5 ] == type )
        return( 5 );
      if( Line[ 21 ] == type )
        return( 21 );
      if( Line[ 37 ] == type )
        return( 37 );
      if( Line[ 49 ] == type )
        return( 49 );
      if( Line[ 57 ] == type )
        return( 57 );
      if( Line[ 65 ] == type )
        return( 65 );
      if( Line[ 72 ] == type )
        return( 72 );
    break;
    case 22:
      if( Line[ 5 ] == type )
        return( 5 );
      if( Line[ 22 ] == type )
        return( 22 );
      if( Line[ 38 ] == type )
        return( 38 );
      if( Line[ 53 ] == type )
        return( 53 );
      if( Line[ 58 ] == type )
        return( 58 );
      if( Line[ 69 ] == type )
        return( 69 );
      if( Line[ 73 ] == type )
        return( 73 );
    break;
    case 23:
      if( Line[ 5 ] == type )
        return( 5 );
      if( Line[ 23 ] == type )
        return( 23 );
      if( Line[ 39 ] == type )
        return( 39 );
      if( Line[ 59 ] == type )
        return( 59 );
    break;

    case 24:
      if( Line[ 6 ] == type )
        return( 6 );
      if( Line[ 20 ] == type )
        return( 20 );
      if( Line[ 40 ] == type )
        return( 40 );
      if( Line[ 60 ] == type )
        return( 60 );
    break;
    case 25:
      if( Line[ 6 ] == type )
        return( 6 );
      if( Line[ 21 ] == type )
        return( 21 );
      if( Line[ 41 ] == type )
        return( 41 );
      if( Line[ 53 ] == type )
        return( 53 );
      if( Line[ 61 ] == type )
        return( 61 );
      if( Line[ 66 ] == type )
        return( 66 );
      if( Line[ 75 ] == type )
        return( 75 );
    break;
    case 26:
      if( Line[ 6 ] == type )
        return( 6 );
      if( Line[ 22 ] == type )
        return( 22 );
      if( Line[ 42 ] == type )
        return( 42 );
      if( Line[ 49 ] == type )
        return( 49 );
      if( Line[ 62 ] == type )
        return( 62 );
      if( Line[ 70 ] == type )
        return( 70 );
      if( Line[ 74 ] == type )
        return( 74 );
    break;
    case 27:
      if( Line[ 6 ] == type )
        return( 6 );
      if( Line[ 23 ] == type )
        return( 23 );
      if( Line[ 43 ] == type )
        return( 43 );
      if( Line[ 63 ] == type )
        return( 63 );
    break;

    case 28:
      if( Line[ 7 ] == type )
        return( 7 );
      if( Line[ 20 ] == type )
        return( 20 );
      if( Line[ 44 ] == type )
        return( 44 );
      if( Line[ 53 ] == type )
        return( 53 );
    break;
    case 29:
      if( Line[ 7 ] == type )
        return( 7 );
      if( Line[ 21 ] == type )
        return( 21 );
      if( Line[ 45 ] == type )
        return( 45 );
      if( Line[ 67 ] == type )
        return( 67 );
    break;
    case 30:
      if( Line[ 7 ] == type )
        return( 7 );
      if( Line[ 22 ] == type )
        return( 22 );
      if( Line[ 46 ] == type )
        return( 46 );
      if( Line[ 71 ] == type )
        return( 71 );
    break;
    case 31:
      if( Line[ 7 ] == type )
        return( 7 );
      if( Line[ 23 ] == type )
        return( 23 );
      if( Line[ 47 ] == type )
        return( 47 );
      if( Line[ 49 ] == type )
        return( 49 );
    break;


    case 32:
      if( Line[ 8 ] == type )
        return( 8 );
      if( Line[ 24 ] == type )
        return( 24 );
      if( Line[ 32 ] == type )
        return( 32 );
      if( Line[ 50 ] == type )
        return( 50 );
    break;
    case 33:
      if( Line[ 8 ] == type )
        return( 8 );
      if( Line[ 25 ] == type )
        return( 25 );
      if( Line[ 33 ] == type )
        return( 33 );
      if( Line[ 68 ] == type )
        return( 68 );
    break;
    case 34:
      if( Line[ 8 ] == type )
        return( 8 );
      if( Line[ 26 ] == type )
        return( 26 );
      if( Line[ 34 ] == type )
        return( 34 );
      if( Line[ 64 ] == type )
        return( 64 );
    break;
    case 35:
      if( Line[ 8 ] == type )
        return( 8 );
      if( Line[ 27 ] == type )
        return( 27 );
      if( Line[ 35 ] == type )
        return( 35 );
      if( Line[ 54 ] == type )
        return( 54 );
    break;

    case 36:
      if( Line[ 9 ] == type )
        return( 9 );
      if( Line[ 24 ] == type )
        return( 24 );
      if( Line[ 36 ] == type )
        return( 36 );
      if( Line[ 60 ] == type )
        return( 60 );
    break;
    case 37:
      if( Line[ 9 ] == type )
        return( 9 );
      if( Line[ 25 ] == type )
        return( 25 );
      if( Line[ 37 ] == type )
        return( 37 );
      if( Line[ 50 ] == type )
        return( 50 );
      if( Line[ 61 ] == type )
        return( 61 );
      if( Line[ 69 ] == type )
        return( 69 );
      if( Line[ 74 ] == type )
        return( 74 );
    break;
    case 38:
      if( Line[ 9 ] == type )
        return( 9 );
      if( Line[ 26 ] == type )
        return( 26 );
      if( Line[ 38 ] == type )
        return( 38 );
      if( Line[ 54 ] == type )
        return( 54 );
      if( Line[ 62 ] == type )
        return( 62 );
      if( Line[ 65 ] == type )
        return( 65 );
      if( Line[ 75 ] == type )
        return( 75 );
    break;
    case 39:
      if( Line[ 9 ] == type )
        return( 9 );
      if( Line[ 27 ] == type )
        return( 27 );
      if( Line[ 39 ] == type )
        return( 39 );
      if( Line[ 63 ] == type )
        return( 63 );
    break;

    case 40:
      if( Line[ 10 ] == type )
        return( 10 );
      if( Line[ 24 ] == type )
        return( 24 );
      if( Line[ 40 ] == type )
        return( 40 );
      if( Line[ 56 ] == type )
        return( 56 );
    break;
    case 41:
      if( Line[ 10 ] == type )
        return( 10 );
      if( Line[ 25 ] == type )
        return( 25 );
      if( Line[ 41 ] == type )
        return( 41 );
      if( Line[ 54 ] == type )
        return( 54 );
      if( Line[ 57 ] == type )
        return( 57 );
      if( Line[ 70 ] == type )
        return( 70 );
      if( Line[ 73 ] == type )
        return( 73 );
    break;
    case 42:
      if( Line[ 10 ] == type )
        return( 10 );
      if( Line[ 26 ] == type )
        return( 26 );
      if( Line[ 42 ] == type )
        return( 42 );
      if( Line[ 50 ] == type )
        return( 50 );
      if( Line[ 58 ] == type )
        return( 58 );
      if( Line[ 66 ] == type )
        return( 66 );
      if( Line[ 72 ] == type )
        return( 72 );
    break;
    case 43:
      if( Line[ 10 ] == type )
        return( 10 );
      if( Line[ 27 ] == type )
        return( 27 );
      if( Line[ 43 ] == type )
        return( 43 );
      if( Line[ 59 ] == type )
        return( 59 );
    break;

    case 44:
      if( Line[ 11 ] == type )
        return( 11 );
      if( Line[ 24 ] == type )
        return( 24 );
      if( Line[ 44 ] == type )
        return( 44 );
      if( Line[ 54 ] == type )
        return( 54 );
    break;
    case 45:
      if( Line[ 11 ] == type )
        return( 11 );
      if( Line[ 25 ] == type )
        return( 25 );
      if( Line[ 45 ] == type )
        return( 45 );
      if( Line[ 71 ] == type )
        return( 71 );
    break;
    case 46:
      if( Line[ 11 ] == type )
        return( 11 );
      if( Line[ 26 ] == type )
        return( 26 );
      if( Line[ 46 ] == type )
        return( 46 );
      if( Line[ 67 ] == type )
        return( 67 );
    break;
    case 47:
      if( Line[ 11 ] == type )
        return( 11 );
      if( Line[ 27 ] == type )
        return( 27 );
      if( Line[ 47 ] == type )
        return( 47 );
      if( Line[ 50 ] == type )
        return( 50 );
    break;


    case 48:
      if( Line[ 12 ] == type )
        return( 12 );
      if( Line[ 28 ] == type )
        return( 28 );
      if( Line[ 32 ] == type )
        return( 32 );
      if( Line[ 51 ] == type )
        return( 51 );
      if( Line[ 60 ] == type )
        return( 60 );
      if( Line[ 68 ] == type )
        return( 68 );
      if( Line[ 74 ] == type )
        return( 74 );
    break;
    case 49:
      if( Line[ 12 ] == type )
        return( 12 );
      if( Line[ 29 ] == type )
        return( 29 );
      if( Line[ 33 ] == type )
        return( 33 );
      if( Line[ 61 ] == type )
        return( 61 );
    break;
    case 50:
      if( Line[ 12 ] == type )
        return( 12 );
      if( Line[ 30 ] == type )
        return( 30 );
      if( Line[ 34 ] == type )
        return( 34 );
      if( Line[ 62 ] == type )
        return( 62 );
    break;
    case 51:
      if( Line[ 12 ] == type )
        return( 12 );
      if( Line[ 31 ] == type )
        return( 31 );
      if( Line[ 35 ] == type )
        return( 35 );
      if( Line[ 55 ] == type )
        return( 55 );
      if( Line[ 63 ] == type )
        return( 63 );
      if( Line[ 64 ] == type )
        return( 64 );
      if( Line[ 75 ] == type )
        return( 75 );
    break;

    case 52:
      if( Line[ 13 ] == type )
        return( 13 );
      if( Line[ 28 ] == type )
        return( 28 );
      if( Line[ 36 ] == type )
        return( 36 );
      if( Line[ 69 ] == type )
        return( 69 );
    break;
    case 53:
      if( Line[ 13 ] == type )
        return( 13 );
      if( Line[ 29 ] == type )
        return( 29 );
      if( Line[ 37 ] == type )
        return( 37 );
      if( Line[ 51 ] == type )
        return( 51 );
    break;
    case 54:
      if( Line[ 13 ] == type )
        return( 13 );
      if( Line[ 30 ] == type )
        return( 30 );
      if( Line[ 38 ] == type )
        return( 38 );
      if( Line[ 55 ] == type )
        return( 55 );
    break;
    case 55:
      if( Line[ 13 ] == type )
        return( 13 );
      if( Line[ 31 ] == type )
        return( 31 );
      if( Line[ 39 ] == type )
        return( 39 );
      if( Line[ 65 ] == type )
        return( 65 );
    break;

    case 56:
      if( Line[ 14 ] == type )
        return( 14 );
      if( Line[ 28 ] == type )
        return( 28 );
      if( Line[ 40 ] == type )
        return( 40 );
      if( Line[ 70 ] == type )
        return( 70 );
    break;
    case 57:
      if( Line[ 14 ] == type )
        return( 14 );
      if( Line[ 29 ] == type )
        return( 29 );
      if( Line[ 41 ] == type )
        return( 41 );
      if( Line[ 55 ] == type )
        return( 55 );
    break;
    case 58:
      if( Line[ 14 ] == type )
        return( 14 );
      if( Line[ 30 ] == type )
        return( 30 );
      if( Line[ 42 ] == type )
        return( 42 );
      if( Line[ 51 ] == type )
        return( 51 );
    break;
    case 59:
      if( Line[ 14 ] == type )
        return( 14 );
      if( Line[ 31 ] == type )
        return( 31 );
      if( Line[ 43 ] == type )
        return( 43 );
      if( Line[ 66 ] == type )
        return( 66 );
    break;

    case 60:
      if( Line[ 15 ] == type )
        return( 15 );
      if( Line[ 28 ] == type )
        return( 28 );
      if( Line[ 44 ] == type )
        return( 44 );
      if( Line[ 55 ] == type )
        return( 55 );
      if( Line[ 56 ] == type )
        return( 56 );
      if( Line[ 71 ] == type )
        return( 71 );
      if( Line[ 73 ] == type )
        return( 73 );
    break;
    case 61:
      if( Line[ 15 ] == type )
        return( 15 );
      if( Line[ 29 ] == type )
        return( 29 );
      if( Line[ 45 ] == type )
        return( 45 );
      if( Line[ 57 ] == type )
        return( 57 );
    break;
    case 62:
      if( Line[ 15 ] == type )
        return( 15 );
      if( Line[ 30 ] == type )
        return( 30 );
      if( Line[ 46 ] == type )
        return( 46 );
      if( Line[ 58 ] == type )
        return( 58 );
    break;
    case 63:
      if( Line[ 15 ] == type )
        return( 15 );
      if( Line[ 31 ] == type )
        return( 31 );
      if( Line[ 47 ] == type )
        return( 47 );
      if( Line[ 51 ] == type )
        return( 51 );
      if( Line[ 59 ] == type )
        return( 59 );
      if( Line[ 67 ] == type )
        return( 67 );
      if( Line[ 72 ] == type )
        return( 72 );
    break;
    default:
      return( -1 );
  }

  return( -1 );
}

int ticboard::TestLine( int LineNumber ) const
{
  int Pos;

  Pos = Tab1[ LineNumber ];

  if( Board[ Pos ] == EMPTY ) {
    return( Pos );
  }

  Pos = Tab2[ LineNumber ];

  if( Board[ Pos ] == EMPTY ) {
    return( Pos );
  }

  Pos = Tab3[ LineNumber ];

  if( Board[ Pos ] == EMPTY ) {
    return( Pos );
  }

  Pos = Tab4[ LineNumber ];

  if( Board[ Pos ] == EMPTY ) {
    return( Pos );
  }

  return( -1 );
}

int ticboard::CheckAllLines( int type ) const
{
  int i;

  for( i = 0; i < 76; i++ ) {
    if( Line[ i ] == type ) {
      return( i );
    }
  }

  return( -1 );
}

void ticboard::AddOne( int Move )
{
  switch( Move ) {
    case 0:
      Line[ 0 ]++;
      Line[ 16 ]++;
      Line[ 32 ]++;
      Line[ 48 ]++;
      Line[ 56 ]++;
      Line[ 64 ]++;
      Line[ 72 ]++;
    break;
    case 1:
      Line[ 0 ]++;
      Line[ 17 ]++;
      Line[ 33 ]++;
      Line[ 57 ]++;
    break;
    case 2:
      Line[ 0 ]++;
      Line[ 18 ]++;
      Line[ 34 ]++;
      Line[ 58 ]++;
    break;
    case 3:
      Line[ 0 ]++;
      Line[ 19 ]++;
      Line[ 35 ]++;
      Line[ 52 ]++;
      Line[ 59 ]++;
      Line[ 68 ]++;
      Line[ 73 ]++;
    break;

    case 4:
      Line[ 1 ]++;
      Line[ 16 ]++;
      Line[ 36 ]++;
      Line[ 65 ]++;
    break;
    case 5:
      Line[ 1 ]++;
      Line[ 17 ]++;
      Line[ 37 ]++;
      Line[ 48 ]++;
    break;
    case 6:
      Line[ 1 ]++;
      Line[ 18 ]++;
      Line[ 38 ]++;
      Line[ 52 ]++;
    break;
    case 7:
      Line[ 1 ]++;
      Line[ 19 ]++;
      Line[ 39 ]++;
      Line[ 69 ]++;
    break;

    case 8:
      Line[ 2 ]++;
      Line[ 16 ]++;
      Line[ 40 ]++;
      Line[ 66 ]++;
    break;
    case 9:
      Line[ 2 ]++;
      Line[ 17 ]++;
      Line[ 41 ]++;
      Line[ 52 ]++;
    break;
    case 10:
      Line[ 2 ]++;
      Line[ 18 ]++;
      Line[ 42 ]++;
      Line[ 48 ]++;
    break;
    case 11:
      Line[ 2 ]++;
      Line[ 19 ]++;
      Line[ 43 ]++;
      Line[ 70 ]++;
    break;

    case 12:
      Line[ 3 ]++;
      Line[ 16 ]++;
      Line[ 44 ]++;
      Line[ 52 ]++;
      Line[ 60 ]++;
      Line[ 67 ]++;
      Line[ 75 ]++;
    break;
    case 13:
      Line[ 3 ]++;
      Line[ 17 ]++;
      Line[ 45 ]++;
      Line[ 61 ]++;
    break;
    case 14:
      Line[ 3 ]++;
      Line[ 18 ]++;
      Line[ 46 ]++;
      Line[ 62 ]++;
    break;
    case 15:
      Line[ 3 ]++;
      Line[ 19 ]++;
      Line[ 47 ]++;
      Line[ 48 ]++;
      Line[ 63 ]++;
      Line[ 71 ]++;
      Line[ 74 ]++;
    break;


    case 16:
      Line[ 4 ]++;
      Line[ 20 ]++;
      Line[ 32 ]++;
      Line[ 49 ]++;
    break;
    case 17:
      Line[ 4 ]++;
      Line[ 21 ]++;
      Line[ 33 ]++;
      Line[ 64 ]++;
    break;
    case 18:
      Line[ 4 ]++;
      Line[ 22 ]++;
      Line[ 34 ]++;
      Line[ 68 ]++;
    break;
    case 19:
      Line[ 4 ]++;
      Line[ 23 ]++;
      Line[ 35 ]++;
      Line[ 53 ]++;
    break;

    case 20:
      Line[ 5 ]++;
      Line[ 20 ]++;
      Line[ 36 ]++;
      Line[ 56 ]++;
    break;
    case 21:
      Line[ 5 ]++;
      Line[ 21 ]++;
      Line[ 37 ]++;
      Line[ 49 ]++;
      Line[ 57 ]++;
      Line[ 65 ]++;
      Line[ 72 ]++;
    break;
    case 22:
      Line[ 5 ]++;
      Line[ 22 ]++;
      Line[ 38 ]++;
      Line[ 53 ]++;
      Line[ 58 ]++;
      Line[ 69 ]++;
      Line[ 73 ]++;
    break;
    case 23:
      Line[ 5 ]++;
      Line[ 23 ]++;
      Line[ 39 ]++;
      Line[ 59 ]++;
    break;

    case 24:
      Line[ 6 ]++;
      Line[ 20 ]++;
      Line[ 40 ]++;
      Line[ 60 ]++;
    break;
    case 25:
      Line[ 6 ]++;
      Line[ 21 ]++;
      Line[ 41 ]++;
      Line[ 53 ]++;
      Line[ 61 ]++;
      Line[ 66 ]++;
      Line[ 75 ]++;
    break;
    case 26:
      Line[ 6 ]++;
      Line[ 22 ]++;
      Line[ 42 ]++;
      Line[ 49 ]++;
      Line[ 62 ]++;
      Line[ 70 ]++;
      Line[ 74 ]++;
    break;
    case 27:
      Line[ 6 ]++;
      Line[ 23 ]++;
      Line[ 43 ]++;
      Line[ 63 ]++;
    break;

    case 28:
      Line[ 7 ]++;
      Line[ 20 ]++;
      Line[ 44 ]++;
      Line[ 53 ]++;
    break;
    case 29:
      Line[ 7 ]++;
      Line[ 21 ]++;
      Line[ 45 ]++;
      Line[ 67 ]++;
    break;
    case 30:
      Line[ 7 ]++;
      Line[ 22 ]++;
      Line[ 46 ]++;
      Line[ 71 ]++;
    break;
    case 31:
      Line[ 7 ]++;
      Line[ 23 ]++;
      Line[ 47 ]++;
      Line[ 49 ]++;
    break;


    case 32:
      Line[ 8 ]++;
      Line[ 24 ]++;
      Line[ 32 ]++;
      Line[ 50 ]++;
    break;
    case 33:
      Line[ 8 ]++;
      Line[ 25 ]++;
      Line[ 33 ]++;
      Line[ 68 ]++;
    break;
    case 34:
      Line[ 8 ]++;
      Line[ 26 ]++;
      Line[ 34 ]++;
      Line[ 64 ]++;
    break;
    case 35:
      Line[ 8 ]++;
      Line[ 27 ]++;
      Line[ 35 ]++;
      Line[ 54 ]++;
    break;

    case 36:
      Line[ 9 ]++;
      Line[ 24 ]++;
      Line[ 36 ]++;
      Line[ 60 ]++;
    break;
    case 37:
      Line[ 9 ]++;
      Line[ 25 ]++;
      Line[ 37 ]++;
      Line[ 50 ]++;
      Line[ 61 ]++;
      Line[ 69 ]++;
      Line[ 74 ]++;
    break;
    case 38:
      Line[ 9 ]++;
      Line[ 26 ]++;
      Line[ 38 ]++;
      Line[ 54 ]++;
      Line[ 62 ]++;
      Line[ 65 ]++;
      Line[ 75 ]++;
    break;
    case 39:
      Line[ 9 ]++;
      Line[ 27 ]++;
      Line[ 39 ]++;
      Line[ 63 ]++;
    break;

    case 40:
      Line[ 10 ]++;
      Line[ 24 ]++;
      Line[ 40 ]++;
      Line[ 56 ]++;
    break;
    case 41:
      Line[ 10 ]++;
      Line[ 25 ]++;
      Line[ 41 ]++;
      Line[ 54 ]++;
      Line[ 57 ]++;
      Line[ 70 ]++;
      Line[ 73 ]++;
    break;
    case 42:
      Line[ 10 ]++;
      Line[ 26 ]++;
      Line[ 42 ]++;
      Line[ 50 ]++;
      Line[ 58 ]++;
      Line[ 66 ]++;
      Line[ 72 ]++;
    break;
    case 43:
      Line[ 10 ]++;
      Line[ 27 ]++;
      Line[ 43 ]++;
      Line[ 59 ]++;
    break;

    case 44:
      Line[ 11 ]++;
      Line[ 24 ]++;
      Line[ 44 ]++;
      Line[ 54 ]++;
    break;
    case 45:
      Line[ 11 ]++;
      Line[ 25 ]++;
      Line[ 45 ]++;
      Line[ 71 ]++;
    break;
    case 46:
      Line[ 11 ]++;
      Line[ 26 ]++;
      Line[ 46 ]++;
      Line[ 67 ]++;
    break;
    case 47:
      Line[ 11 ]++;
      Line[ 27 ]++;
      Line[ 47 ]++;
      Line[ 50 ]++;
    break;


    case 48:
      Line[ 12 ]++;
      Line[ 28 ]++;
      Line[ 32 ]++;
      Line[ 51 ]++;
      Line[ 60 ]++;
      Line[ 68 ]++;
      Line[ 74 ]++;
    break;
    case 49:
      Line[ 12 ]++;
      Line[ 29 ]++;
      Line[ 33 ]++;
      Line[ 61 ]++;
    break;
    case 50:
      Line[ 12 ]++;
      Line[ 30 ]++;
      Line[ 34 ]++;
      Line[ 62 ]++;
    break;
    case 51:
      Line[ 12 ]++;
      Line[ 31 ]++;
      Line[ 35 ]++;
      Line[ 55 ]++;
      Line[ 63 ]++;
      Line[ 64 ]++;
      Line[ 75 ]++;
    break;

    case 52:
      Line[ 13 ]++;
      Line[ 28 ]++;
      Line[ 36 ]++;
      Line[ 69 ]++;
    break;
    case 53:
      Line[ 13 ]++;
      Line[ 29 ]++;
      Line[ 37 ]++;
      Line[ 51 ]++;
    break;
    case 54:
      Line[ 13 ]++;
      Line[ 30 ]++;
      Line[ 38 ]++;
      Line[ 55 ]++;
    break;
    case 55:
      Line[ 13 ]++;
      Line[ 31 ]++;
      Line[ 39 ]++;
      Line[ 65 ]++;
    break;

    case 56:
      Line[ 14 ]++;
      Line[ 28 ]++;
      Line[ 40 ]++;
      Line[ 70 ]++;
    break;
    case 57:
      Line[ 14 ]++;
      Line[ 29 ]++;
      Line[ 41 ]++;
      Line[ 55 ]++;
    break;
    case 58:
      Line[ 14 ]++;
      Line[ 30 ]++;
      Line[ 42 ]++;
      Line[ 51 ]++;
    break;
    case 59:
      Line[ 14 ]++;
      Line[ 31 ]++;
      Line[ 43 ]++;
      Line[ 66 ]++;
    break;

    case 60:
      Line[ 15 ]++;
      Line[ 28 ]++;
      Line[ 44 ]++;
      Line[ 55 ]++;
      Line[ 56 ]++;
      Line[ 71 ]++;
      Line[ 73 ]++;
    break;
    case 61:
      Line[ 15 ]++;
      Line[ 29 ]++;
      Line[ 45 ]++;
      Line[ 57 ]++;
    break;
    case 62:
      Line[ 15 ]++;
      Line[ 30 ]++;
      Line[ 46 ]++;
      Line[ 58 ]++;
    break;
    case 63:
      Line[ 15 ]++;
      Line[ 31 ]++;
      Line[ 47 ]++;
      Line[ 51 ]++;
      Line[ 59 ]++;
      Line[ 67 ]++;
      Line[ 72 ]++;
    break;
    default:
      return;
  }
}

void ticboard::SubOne( int Move )
{
  switch( Move ) {
    case 0:
      Line[ 0 ]--;
      Line[ 16 ]--;
      Line[ 32 ]--;
      Line[ 48 ]--;
      Line[ 56 ]--;
      Line[ 64 ]--;
      Line[ 72 ]--;
    break;
    case 1:
      Line[ 0 ]--;
      Line[ 17 ]--;
      Line[ 33 ]--;
      Line[ 57 ]--;
    break;
    case 2:
      Line[ 0 ]--;
      Line[ 18 ]--;
      Line[ 34 ]--;
      Line[ 58 ]--;
    break;
    case 3:
      Line[ 0 ]--;
      Line[ 19 ]--;
      Line[ 35 ]--;
      Line[ 52 ]--;
      Line[ 59 ]--;
      Line[ 68 ]--;
      Line[ 73 ]--;
    break;

    case 4:
      Line[ 1 ]--;
      Line[ 16 ]--;
      Line[ 36 ]--;
      Line[ 65 ]--;
    break;
    case 5:
      Line[ 1 ]--;
      Line[ 17 ]--;
      Line[ 37 ]--;
      Line[ 48 ]--;
    break;
    case 6:
      Line[ 1 ]--;
      Line[ 18 ]--;
      Line[ 38 ]--;
      Line[ 52 ]--;
    break;
    case 7:
      Line[ 1 ]--;
      Line[ 19 ]--;
      Line[ 39 ]--;
      Line[ 69 ]--;
    break;

    case 8:
      Line[ 2 ]--;
      Line[ 16 ]--;
      Line[ 40 ]--;
      Line[ 66 ]--;
    break;
    case 9:
      Line[ 2 ]--;
      Line[ 17 ]--;
      Line[ 41 ]--;
      Line[ 52 ]--;
    break;
    case 10:
      Line[ 2 ]--;
      Line[ 18 ]--;
      Line[ 42 ]--;
      Line[ 48 ]--;
    break;
    case 11:
      Line[ 2 ]--;
      Line[ 19 ]--;
      Line[ 43 ]--;
      Line[ 70 ]--;
    break;

    case 12:
      Line[ 3 ]--;
      Line[ 16 ]--;
      Line[ 44 ]--;
      Line[ 52 ]--;
      Line[ 60 ]--;
      Line[ 67 ]--;
      Line[ 75 ]--;
    break;
    case 13:
      Line[ 3 ]--;
      Line[ 17 ]--;
      Line[ 45 ]--;
      Line[ 61 ]--;
    break;
    case 14:
      Line[ 3 ]--;
      Line[ 18 ]--;
      Line[ 46 ]--;
      Line[ 62 ]--;
    break;
    case 15:
      Line[ 3 ]--;
      Line[ 19 ]--;
      Line[ 47 ]--;
      Line[ 48 ]--;
      Line[ 63 ]--;
      Line[ 71 ]--;
      Line[ 74 ]--;
    break;


    case 16:
      Line[ 4 ]--;
      Line[ 20 ]--;
      Line[ 32 ]--;
      Line[ 49 ]--;
    break;
    case 17:
      Line[ 4 ]--;
      Line[ 21 ]--;
      Line[ 33 ]--;
      Line[ 64 ]--;
    break;
    case 18:
      Line[ 4 ]--;
      Line[ 22 ]--;
      Line[ 34 ]--;
      Line[ 68 ]--;
    break;
    case 19:
      Line[ 4 ]--;
      Line[ 23 ]--;
      Line[ 35 ]--;
      Line[ 53 ]--;
    break;

    case 20:
      Line[ 5 ]--;
      Line[ 20 ]--;
      Line[ 36 ]--;
      Line[ 56 ]--;
    break;
    case 21:
      Line[ 5 ]--;
      Line[ 21 ]--;
      Line[ 37 ]--;
      Line[ 49 ]--;
      Line[ 57 ]--;
      Line[ 65 ]--;
      Line[ 72 ]--;
    break;
    case 22:
      Line[ 5 ]--;
      Line[ 22 ]--;
      Line[ 38 ]--;
      Line[ 53 ]--;
      Line[ 58 ]--;
      Line[ 69 ]--;
      Line[ 73 ]--;
    break;
    case 23:
      Line[ 5 ]--;
      Line[ 23 ]--;
      Line[ 39 ]--;
      Line[ 59 ]--;
    break;

    case 24:
      Line[ 6 ]--;
      Line[ 20 ]--;
      Line[ 40 ]--;
      Line[ 60 ]--;
    break;
    case 25:
      Line[ 6 ]--;
      Line[ 21 ]--;
      Line[ 41 ]--;
      Line[ 53 ]--;
      Line[ 61 ]--;
      Line[ 66 ]--;
      Line[ 75 ]--;
    break;
    case 26:
      Line[ 6 ]--;
      Line[ 22 ]--;
      Line[ 42 ]--;
      Line[ 49 ]--;
      Line[ 62 ]--;
      Line[ 70 ]--;
      Line[ 74 ]--;
    break;
    case 27:
      Line[ 6 ]--;
      Line[ 23 ]--;
      Line[ 43 ]--;
      Line[ 63 ]--;
    break;

    case 28:
      Line[ 7 ]--;
      Line[ 20 ]--;
      Line[ 44 ]--;
      Line[ 53 ]--;
    break;
    case 29:
      Line[ 7 ]--;
      Line[ 21 ]--;
      Line[ 45 ]--;
      Line[ 67 ]--;
    break;
    case 30:
      Line[ 7 ]--;
      Line[ 22 ]--;
      Line[ 46 ]--;
      Line[ 71 ]--;
    break;
    case 31:
      Line[ 7 ]--;
      Line[ 23 ]--;
      Line[ 47 ]--;
      Line[ 49 ]--;
    break;


    case 32:
      Line[ 8 ]--;
      Line[ 24 ]--;
      Line[ 32 ]--;
      Line[ 50 ]--;
    break;
    case 33:
      Line[ 8 ]--;
      Line[ 25 ]--;
      Line[ 33 ]--;
      Line[ 68 ]--;
    break;
    case 34:
      Line[ 8 ]--;
      Line[ 26 ]--;
      Line[ 34 ]--;
      Line[ 64 ]--;
    break;
    case 35:
      Line[ 8 ]--;
      Line[ 27 ]--;
      Line[ 35 ]--;
      Line[ 54 ]--;
    break;

    case 36:
      Line[ 9 ]--;
      Line[ 24 ]--;
      Line[ 36 ]--;
      Line[ 60 ]--;
    break;
    case 37:
      Line[ 9 ]--;
      Line[ 25 ]--;
      Line[ 37 ]--;
      Line[ 50 ]--;
      Line[ 61 ]--;
      Line[ 69 ]--;
      Line[ 74 ]--;
    break;
    case 38:
      Line[ 9 ]--;
      Line[ 26 ]--;
      Line[ 38 ]--;
      Line[ 54 ]--;
      Line[ 62 ]--;
      Line[ 65 ]--;
      Line[ 75 ]--;
    break;
    case 39:
      Line[ 9 ]--;
      Line[ 27 ]--;
      Line[ 39 ]--;
      Line[ 63 ]--;
    break;

    case 40:
      Line[ 10 ]--;
      Line[ 24 ]--;
      Line[ 40 ]--;
      Line[ 56 ]--;
    break;
    case 41:
      Line[ 10 ]--;
      Line[ 25 ]--;
      Line[ 41 ]--;
      Line[ 54 ]--;
      Line[ 57 ]--;
      Line[ 70 ]--;
      Line[ 73 ]--;
    break;
    case 42:
      Line[ 10 ]--;
      Line[ 26 ]--;
      Line[ 42 ]--;
      Line[ 50 ]--;
      Line[ 58 ]--;
      Line[ 66 ]--;
      Line[ 72 ]--;
    break;
    case 43:
      Line[ 10 ]--;
      Line[ 27 ]--;
      Line[ 43 ]--;
      Line[ 59 ]--;
    break;

    case 44:
      Line[ 11 ]--;
      Line[ 24 ]--;
      Line[ 44 ]--;
      Line[ 54 ]--;
    break;
    case 45:
      Line[ 11 ]--;
      Line[ 25 ]--;
      Line[ 45 ]--;
      Line[ 71 ]--;
    break;
    case 46:
      Line[ 11 ]--;
      Line[ 26 ]--;
      Line[ 46 ]--;
      Line[ 67 ]--;
    break;
    case 47:
      Line[ 11 ]--;
      Line[ 27 ]--;
      Line[ 47 ]--;
      Line[ 50 ]--;
    break;


    case 48:
      Line[ 12 ]--;
      Line[ 28 ]--;
      Line[ 32 ]--;
      Line[ 51 ]--;
      Line[ 60 ]--;
      Line[ 68 ]--;
      Line[ 74 ]--;
    break;
    case 49:
      Line[ 12 ]--;
      Line[ 29 ]--;
      Line[ 33 ]--;
      Line[ 61 ]--;
    break;
    case 50:
      Line[ 12 ]--;
      Line[ 30 ]--;
      Line[ 34 ]--;
      Line[ 62 ]--;
    break;
    case 51:
      Line[ 12 ]--;
      Line[ 31 ]--;
      Line[ 35 ]--;
      Line[ 55 ]--;
      Line[ 63 ]--;
      Line[ 64 ]--;
      Line[ 75 ]--;
    break;

    case 52:
      Line[ 13 ]--;
      Line[ 28 ]--;
      Line[ 36 ]--;
      Line[ 69 ]--;
    break;
    case 53:
      Line[ 13 ]--;
      Line[ 29 ]--;
      Line[ 37 ]--;
      Line[ 51 ]--;
    break;
    case 54:
      Line[ 13 ]--;
      Line[ 30 ]--;
      Line[ 38 ]--;
      Line[ 55 ]--;
    break;
    case 55:
      Line[ 13 ]--;
      Line[ 31 ]--;
      Line[ 39 ]--;
      Line[ 65 ]--;
    break;

    case 56:
      Line[ 14 ]--;
      Line[ 28 ]--;
      Line[ 40 ]--;
      Line[ 70 ]--;
    break;
    case 57:
      Line[ 14 ]--;
      Line[ 29 ]--;
      Line[ 41 ]--;
      Line[ 55 ]--;
    break;
    case 58:
      Line[ 14 ]--;
      Line[ 30 ]--;
      Line[ 42 ]--;
      Line[ 51 ]--;
    break;
    case 59:
      Line[ 14 ]--;
      Line[ 31 ]--;
      Line[ 43 ]--;
      Line[ 66 ]--;
    break;

    case 60:
      Line[ 15 ]--;
      Line[ 28 ]--;
      Line[ 44 ]--;
      Line[ 55 ]--;
      Line[ 56 ]--;
      Line[ 71 ]--;
      Line[ 73 ]--;
    break;
    case 61:
      Line[ 15 ]--;
      Line[ 29 ]--;
      Line[ 45 ]--;
      Line[ 57 ]--;
    break;
    case 62:
      Line[ 15 ]--;
      Line[ 30 ]--;
      Line[ 46 ]--;
      Line[ 58 ]--;
    break;
    case 63:
      Line[ 15 ]--;
      Line[ 31 ]--;
      Line[ 47 ]--;
      Line[ 51 ]--;
      Line[ 59 ]--;
      Line[ 67 ]--;
      Line[ 72 ]--;
    break;
    default:
      return;
  }
}

void ticboard::PutCross( int Move )
{
  Board[ Move ] = CROSS;

  AddOne( Move );
}

void ticboard::PutNol( int Move )
{
  Board[ Move ] = NOL;

  SubOne( Move );
}

void ticboard::DelCross( int Move )
{
  Board[ Move ] = EMPTY;

  SubOne( Move );
}

void ticboard::DelNol( int Move )
{
  Board[ Move ] = EMPTY;

  AddOne( Move );
}

int ticboard::CountPieces( void ) const
{
  int i;
  int Count;

  Count = 0;

  for( i = 0; i < 64; i++ ) {
    if( Board[ i ] != EMPTY ) {
      Count++;
    }
  }

  return( Count );
}

int ticboard::FindSpecCross( int TmpLine, int OldNol, int depth )
{
  int TmpLine1;
  int Move;
  int Move1;
  int RetCode;

  Move = TestLine( TmpLine );
  PutCross( Move );

  if( Check( OldNol, 3 * NOL ) >= 0 ) {
    DelCross( Move );
    return( -1 );
  }

  TmpLine1  = Check( Move, 3 * CROSS );

  if( TmpLine1 >= 0 ) {
    Move1 = TestLine( TmpLine1 );
    PutNol( Move1 );
    RetCode = FindCross( Move, Move1, depth );
    DelNol( Move1 );
    DelCross( Move );
    return( RetCode );
  }

  DelCross( Move );
  return( 0 );
}

int ticboard::FindCross( int OldCross, int OldNol, int depth )
{
  int i;
  int Move;
  int TmpLine;
  int RetCode;
  int Next;

  if( Check( OldCross, 3 * CROSS ) >= 0 )
    return( 1 );

  if( depth < 0 )
    return( 0 );

  TmpLine = Check( OldNol, 3 * NOL );

  if( TmpLine >= 0 ) {
    return( FindSpecCross( TmpLine, OldNol, depth ) );
  }

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * CROSS );
      if( TmpLine >= 0 ) {
        PutCross( Next );
        Move = TestLine( TmpLine );
        PutNol( Move );
        RetCode = FindCross( Next, Move, depth - 1 );
        DelNol( Move );
        DelCross( Next );
        if( RetCode == 1 ) {
          return( 1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::FindFastCross( int depth )
{
  int             i;
  int             Move;
  int             TmpLine;
  int             RetCode;
  int             Next;

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * CROSS );
      if( TmpLine >= 0 ) {
        PutCross( Next );
        Move = TestLine( TmpLine );
        PutNol( Move );
        RetCode = FindCross( Next, Move, depth );
        DelNol( Move );
        DelCross( Next );
        if( RetCode == 1 ) {
          return( 1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::FindSpecNol( int TmpLine, int OldCross, int depth )
{
  int TmpLine1;
  int Move;
  int Move1;
  int RetCode;

  Move = TestLine( TmpLine );
  PutNol( Move );

  if( Check( OldCross, 3 * CROSS ) >= 0 ) {
    DelNol( Move );
    return( 1 );
  }

  TmpLine1  = Check( Move, 3 * NOL );

  if( TmpLine1 >= 0 ) {
    Move1 = TestLine( TmpLine1 );
    PutCross( Move1 );
    RetCode = FindNol( Move, Move1, depth );
    DelCross( Move1 );
    DelNol( Move );
    return( RetCode );
  }

  DelNol( Move );
  return( 0 );
}

int ticboard::FindNol( int OldNol, int OldCross, int depth )
{
  int i;
  int Move;
  int TmpLine;
  int RetCode;
  int Next;

  if( Check( OldNol, 3 * NOL ) >= 0 )
    return( -1 );

  if( depth < 0 )
    return( 0 );

  TmpLine = Check( OldCross, 3 * CROSS );

  if( TmpLine >= 0 ) {
    return( FindSpecNol( TmpLine, OldCross, depth ) );
  }

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * NOL );
      if( TmpLine >= 0 ) {
        PutNol( Next );
        Move = TestLine( TmpLine );
        PutCross( Move );
        RetCode = FindNol( Next, Move, depth - 1 );
        DelCross( Move );
        DelNol( Next );
        if( RetCode == -1 ) {
          return( -1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::FindFastNol( int depth )
{
  int i;
  int Move;
  int TmpLine;
  int RetCode;
  int Next;

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * NOL );
      if( TmpLine >= 0 ) {
        PutNol( Next );
        Move = TestLine( TmpLine );
        PutCross( Move );
        RetCode = FindNol( Next, Move, depth );
        DelCross( Move );
        DelNol( Next );
        if( RetCode == -1 ) {
          return( -1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::FindAllCross( int OldCross, int OldNol, int depth, int FastDepth )
{
  int i;
  int Move;
  int TmpLine;
  int TmpRetCode;
  int RetCode;
  int Next;

  if( Check( OldCross, 3 * CROSS ) >= 0 ) {
    return( 1 );
  }

  if( depth < 0 )
    return( 0 );

  TmpLine = Check( OldNol, 3 * NOL );

  if( TmpLine >= 0 ) {
    Move = TestLine( TmpLine );
    PutCross( Move );
    RetCode = FindAllNol( OldNol, Move, depth - 1, FastDepth - 1 );
    DelCross( Move );

    return( RetCode );
  }

  if( FindFastCross( FastDepth ) == 1 ) {
    return( 1 );
  }

  RetCode = -2;

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      PutCross( Next );
      TmpRetCode = FindAllNol( OldNol, Next, depth - 1, FastDepth - 1 );
      DelCross( Next );

      if( TmpRetCode > RetCode ) {
         RetCode = TmpRetCode;
      }
    }
  }

  if( RetCode == -2 ) {
    return( 0 );
  }

  return( RetCode );
}

int ticboard::FindAllNol( int OldNol, int OldCross, int depth, int FastDepth )
{
  int i;
  int Move;
  int TmpLine;
  int TmpRetCode;
  int RetCode;
  int Next;

  if( Check( OldNol, 3 * NOL ) >= 0 ) {
    return( -1 );
  }

  if( depth < 0 )
    return( 0 );

  TmpLine = Check( OldCross, 3 * CROSS );

  if( TmpLine >= 0 ) {
    Move = TestLine( TmpLine );
    PutNol( Move );
    RetCode = FindAllCross( OldCross, Move, depth - 1, FastDepth - 1 );
    DelNol( Move );

    return( RetCode );
  }

  if( FindFastNol( FastDepth ) == -1 ) {
    return( -1 );
  }

  RetCode = 2;

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      PutNol( Next );
      TmpRetCode = FindAllCross( OldCross, Next, depth - 1, FastDepth - 1 );
      DelNol( Next );

      if( TmpRetCode == -1 ) {
        return( -1 );
      }

      if( TmpRetCode < RetCode ) {
        RetCode = TmpRetCode;
      }
    }
  }

  if( RetCode == 2 ) {
    return( 0 );
  }

  return( RetCode );
}

int ticboard::FindSpecCrossW( int TmpLine, int OldNol, int depth, int FastPCount, int * FastWinMove )
{
  int TmpLine1;
  int Move;
  int Move1;
  int RetCode;

  Move = TestLine( TmpLine );
  PutCross( Move );
  FastWinMove[ FastPCount ] = Move;

  if( Check( OldNol, 3 * NOL ) >= 0 ) {
    DelCross( Move );
    return( -1 );
  }

  TmpLine1  = Check( Move, 3 * CROSS );

  if( TmpLine1 >= 0 ) {
    Move1 = TestLine( TmpLine1 );
    PutNol( Move1 );
    FastWinMove[ FastPCount + 1 ] = Move1;
    RetCode = FindCrossW( Move, Move1, depth, FastPCount + 2, FastWinMove );
    DelNol( Move1 );
    DelCross( Move );
    return( RetCode );
  }

  DelCross( Move );
  return( 0 );
}

int ticboard::FindCrossW( int OldCross, int OldNol, int depth, int FastPCount, int * FastWinMove )
{
  int i;
  int Move;
  int TmpLine;
  int RetCode;
  int Next;

  TmpLine = Check( OldCross, 3 * CROSS );

  if( TmpLine >= 0 ) {
    Move = TestLine( TmpLine );
    FastWinMove[ FastPCount ] = Move;
    return( 1 );
  }

  if( depth < 0 )
    return( 0 );

  TmpLine = Check( OldNol, 3 * NOL );

  if( TmpLine >= 0 ) {
    return( FindSpecCrossW( TmpLine, OldNol, depth, FastPCount, FastWinMove ) );
  }

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * CROSS );
      if( TmpLine >= 0 ) {
        PutCross( Next );
        FastWinMove[ FastPCount ] = Next;
        Move = TestLine( TmpLine );
        PutNol( Move );
        FastWinMove[ FastPCount + 1 ] = Move;
        RetCode = FindCrossW( Next, Move, depth - 1, FastPCount + 2, FastWinMove );
        DelNol( Move );
        DelCross( Next );
        if( RetCode == 1 ) {
          return( 1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::FindFastCrossW( int depth, int * FastWinMove )
{
  int i;
  int Move;
  int TmpLine;
  int RetCode;
  int Next;

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * CROSS );
      if( TmpLine >= 0 ) {
        PutCross( Next );
        FastWinMove[ 0 ] = Next;
        Move = TestLine( TmpLine );
        PutNol( Move );
        FastWinMove[ 1 ] = Move;
        RetCode = FindCrossW( Next, Move, depth, 2, FastWinMove );
        DelNol( Move );
        DelCross( Next );
        if( RetCode == 1 ) {
          return( 1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::FindSpecNolW( int TmpLine, int OldCross, int depth )
{
  int TmpLine1;
  int Move;
  int Move1;
  int RetCode;

  Move = TestLine( TmpLine );
  PutNol( Move );

  if( Check( OldCross, 3 * CROSS ) >= 0 ) {
    DelNol( Move );
    return( 1 );
  }

  TmpLine1  = Check( Move, 3 * NOL );

  if( TmpLine1 >= 0 ) {
    Move1 = TestLine( TmpLine1 );
    PutCross( Move1 );
    RetCode = FindNolW( Move, Move1, depth );
    DelCross( Move1 );
    DelNol( Move );
    return( RetCode );
  }

  DelNol( Move );
  return( 0 );
}

int ticboard::FindNolW( int OldNol, int OldCross, int depth )
{
  int i;
  int Move;
  int TmpLine;
  int RetCode;
  int Next;

  if( Check( OldNol, 3 * NOL ) >= 0 )
    return( -1 );

  if( depth < 0 )
    return( 0 );

  TmpLine = Check( OldCross, 3 * CROSS );

  if( TmpLine >= 0 ) {
    return( FindSpecNolW( TmpLine, OldCross, depth ) );
  }

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];
    if( Board[ Next ] == EMPTY ) {
      TmpLine = Check( Next, 2 * NOL );
      if( TmpLine >= 0 ) {
        PutNol( Next );
        Move = TestLine( TmpLine );
        PutCross( Move );
        RetCode = FindNolW( Next, Move, depth - 1 );
        DelCross( Move );
        DelNol( Next );
        if( RetCode == -1 ) {
          return( -1 );
        }
      }
    }
  }

  return( 0 );
}

int ticboard::LineEval( int A1, int A2, int A3, int A4 ) const
{
  int cross;
  int nol;
  int pusto;

  cross = 0;
  nol   = 0;
  pusto = 0;

  if( A1 == CROSS ) {
    cross++;
  }
  else {
    if( A1 == NOL ) {
      nol++;
    }
    else {
      pusto++;
    }
  }

  if( A2 == CROSS ) {
    cross++;
  }
  else {
    if( A2 == NOL ) {
      nol++;
    }
    else {
      pusto++;
    }
  }

  if( A3 == CROSS ) {
    cross++;
  }
  else {
    if( A3 == NOL ) {
      nol++;
    }
    else {
      pusto++;
    }
  }

  if( A4 == CROSS ) {
    cross++;
  }
  else {
    if( A4 == NOL ) {
      nol++;
    }
    else {
      pusto++;
    }
  }

  if( cross == 4 ) {
    return( 100 );
  }

  if( nol == 4 ) {
    return( -100 );
  }

  if( ( cross == 2 ) && ( pusto == 2 ) ) {
    return( 2 );
  }

  if( ( cross == 1 ) && ( pusto == 3 ) ) {
    return( 1 );
  }

  if( ( nol == 2 ) && ( pusto == 2 ) ) {
    return( -2 );
  }

  if( ( nol == 1 ) && ( pusto == 3 ) ) {
    return( -1 );
  }

  if( ( cross == 3 ) && ( pusto == 1 ) ) {
    return( 1 );
  }

  if( ( nol == 3 ) && ( pusto == 1 ) ) {
    return( -1 );
  }

  return( 0 );
}

int ticboard::Evalu( void ) const
{
  int Value;

  Value = 0;

  Value = Value + LineEval( Board[ 0 ], Board[ 1 ], Board[ 2 ], Board[ 3 ] );
  Value = Value + LineEval( Board[ 4 ], Board[ 5 ], Board[ 6 ], Board[ 7 ] );
  Value = Value + LineEval( Board[ 8 ], Board[ 9 ], Board[ 10 ], Board[ 11 ] );
  Value = Value + LineEval( Board[ 12 ], Board[ 13 ], Board[ 14 ], Board[ 15 ] );
  Value = Value + LineEval( Board[ 16 ], Board[ 17 ], Board[ 18 ], Board[ 19 ] );
  Value = Value + LineEval( Board[ 20 ], Board[ 21 ], Board[ 22 ], Board[ 23 ] );
  Value = Value + LineEval( Board[ 24 ], Board[ 25 ], Board[ 26 ], Board[ 27 ] );
  Value = Value + LineEval( Board[ 28 ], Board[ 29 ], Board[ 30 ], Board[ 31 ] );
  Value = Value + LineEval( Board[ 32 ], Board[ 33 ], Board[ 34 ], Board[ 35 ] );
  Value = Value + LineEval( Board[ 36 ], Board[ 37 ], Board[ 38 ], Board[ 39 ] );
  Value = Value + LineEval( Board[ 40 ], Board[ 41 ], Board[ 42 ], Board[ 43 ] );
  Value = Value + LineEval( Board[ 44 ], Board[ 45 ], Board[ 46 ], Board[ 47 ] );
  Value = Value + LineEval( Board[ 48 ], Board[ 49 ], Board[ 50 ], Board[ 51 ] );
  Value = Value + LineEval( Board[ 52 ], Board[ 53 ], Board[ 54 ], Board[ 55 ] );
  Value = Value + LineEval( Board[ 56 ], Board[ 57 ], Board[ 58 ], Board[ 59 ] );
  Value = Value + LineEval( Board[ 60 ], Board[ 61 ], Board[ 62 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 0 ], Board[ 4 ], Board[ 8 ], Board[ 12 ] );
  Value = Value + LineEval( Board[ 1 ], Board[ 5 ], Board[ 9 ], Board[ 13 ] );
  Value = Value + LineEval( Board[ 2 ], Board[ 6 ], Board[ 10 ], Board[ 14 ] );
  Value = Value + LineEval( Board[ 3 ], Board[ 7 ], Board[ 11 ], Board[ 15 ] );
  Value = Value + LineEval( Board[ 16 ], Board[ 20 ], Board[ 24 ], Board[ 28 ] );
  Value = Value + LineEval( Board[ 17 ], Board[ 21 ], Board[ 25 ], Board[ 29 ] );
  Value = Value + LineEval( Board[ 18 ], Board[ 22 ], Board[ 26 ], Board[ 30 ] );
  Value = Value + LineEval( Board[ 19 ], Board[ 23 ], Board[ 27 ], Board[ 31 ] );
  Value = Value + LineEval( Board[ 32 ], Board[ 36 ], Board[ 40 ], Board[ 44 ] );
  Value = Value + LineEval( Board[ 33 ], Board[ 37 ], Board[ 41 ], Board[ 45 ] );
  Value = Value + LineEval( Board[ 34 ], Board[ 38 ], Board[ 42 ], Board[ 46 ] );
  Value = Value + LineEval( Board[ 35 ], Board[ 39 ], Board[ 43 ], Board[ 47 ] );
  Value = Value + LineEval( Board[ 48 ], Board[ 52 ], Board[ 56 ], Board[ 60 ] );
  Value = Value + LineEval( Board[ 49 ], Board[ 53 ], Board[ 57 ], Board[ 61 ] );
  Value = Value + LineEval( Board[ 50 ], Board[ 54 ], Board[ 58 ], Board[ 62 ] );
  Value = Value + LineEval( Board[ 51 ], Board[ 55 ], Board[ 59 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 0 ], Board[ 16 ], Board[ 32 ], Board[ 48 ] );
  Value = Value + LineEval( Board[ 1 ], Board[ 17 ], Board[ 33 ], Board[ 49 ] );
  Value = Value + LineEval( Board[ 2 ], Board[ 18 ], Board[ 34 ], Board[ 50 ] );
  Value = Value + LineEval( Board[ 3 ], Board[ 19 ], Board[ 35 ], Board[ 51 ] );
  Value = Value + LineEval( Board[ 4 ], Board[ 20 ], Board[ 36 ], Board[ 52 ] );
  Value = Value + LineEval( Board[ 5 ], Board[ 21 ], Board[ 37 ], Board[ 53 ] );
  Value = Value + LineEval( Board[ 6 ], Board[ 22 ], Board[ 38 ], Board[ 54 ] );
  Value = Value + LineEval( Board[ 7 ], Board[ 23 ], Board[ 39 ], Board[ 55 ] );
  Value = Value + LineEval( Board[ 8 ], Board[ 24 ], Board[ 40 ], Board[ 56 ] );
  Value = Value + LineEval( Board[ 9 ], Board[ 25 ], Board[ 41 ], Board[ 57 ] );
  Value = Value + LineEval( Board[ 10 ], Board[ 26 ], Board[ 42 ], Board[ 58 ] );
  Value = Value + LineEval( Board[ 11 ], Board[ 27 ], Board[ 43 ], Board[ 59 ] );
  Value = Value + LineEval( Board[ 12 ], Board[ 28 ], Board[ 44 ], Board[ 60 ] );
  Value = Value + LineEval( Board[ 13 ], Board[ 29 ], Board[ 45 ], Board[ 61 ] );
  Value = Value + LineEval( Board[ 14 ], Board[ 30 ], Board[ 46 ], Board[ 62 ] );
  Value = Value + LineEval( Board[ 15 ], Board[ 31 ], Board[ 47 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 0 ], Board[ 5 ], Board[ 10 ], Board[ 15 ] );
  Value = Value + LineEval( Board[ 16 ], Board[ 21 ], Board[ 26 ], Board[ 31 ] );
  Value = Value + LineEval( Board[ 32 ], Board[ 37 ], Board[ 42 ], Board[ 47 ] );
  Value = Value + LineEval( Board[ 48 ], Board[ 53 ], Board[ 58 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 3 ], Board[ 6 ], Board[ 9 ], Board[ 12 ] );
  Value = Value + LineEval( Board[ 19 ], Board[ 22 ], Board[ 25 ], Board[ 28 ] );
  Value = Value + LineEval( Board[ 35 ], Board[ 38 ], Board[ 41 ], Board[ 44 ] );
  Value = Value + LineEval( Board[ 51 ], Board[ 54 ], Board[ 57 ], Board[ 60 ] );
  Value = Value + LineEval( Board[ 0 ], Board[ 20 ], Board[ 40 ], Board[ 60 ] );
  Value = Value + LineEval( Board[ 1 ], Board[ 21 ], Board[ 41 ], Board[ 61 ] );
  Value = Value + LineEval( Board[ 2 ], Board[ 22 ], Board[ 42 ], Board[ 62 ] );
  Value = Value + LineEval( Board[ 3 ], Board[ 23 ], Board[ 43 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 12 ], Board[ 24 ], Board[ 36 ], Board[ 48 ] );
  Value = Value + LineEval( Board[ 13 ], Board[ 25 ], Board[ 37 ], Board[ 49 ] );
  Value = Value + LineEval( Board[ 14 ], Board[ 26 ], Board[ 38 ], Board[ 50 ] );
  Value = Value + LineEval( Board[ 15 ], Board[ 27 ], Board[ 39 ], Board[ 51 ] );
  Value = Value + LineEval( Board[ 0 ], Board[ 17 ], Board[ 34 ], Board[ 51 ] );
  Value = Value + LineEval( Board[ 4 ], Board[ 21 ], Board[ 38 ], Board[ 55 ] );
  Value = Value + LineEval( Board[ 8 ], Board[ 25 ], Board[ 42 ], Board[ 59 ] );
  Value = Value + LineEval( Board[ 12 ], Board[ 29 ], Board[ 46 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 3 ], Board[ 18 ], Board[ 33 ], Board[ 48 ] );
  Value = Value + LineEval( Board[ 7 ], Board[ 22 ], Board[ 37 ], Board[ 52 ] );
  Value = Value + LineEval( Board[ 11 ], Board[ 26 ], Board[ 41 ], Board[ 56 ] );
  Value = Value + LineEval( Board[ 15 ], Board[ 30 ], Board[ 45 ], Board[ 60 ] );
  Value = Value + LineEval( Board[ 0 ], Board[ 21 ], Board[ 42 ], Board[ 63 ] );
  Value = Value + LineEval( Board[ 3 ], Board[ 22 ], Board[ 41 ], Board[ 60 ] );
  Value = Value + LineEval( Board[ 15 ], Board[ 26 ], Board[ 37 ], Board[ 48 ] );
  Value = Value + LineEval( Board[ 12 ], Board[ 25 ], Board[ 38 ], Board[ 51 ] );

  return( Value );
}

int ticboard::GetComputerMove( int Level )
{
  int    i;
  int    j;
  int    Next;
  int    TmpRetCode;
  int    BoardEval[ 64 ];
  int    MaxVal;
  int    BestMove;

  for( i = 0; i < 64; i++ ) {
    Next = Arr[ i ];

    if( Board[ Next ] == EMPTY ) {
      PutCross( Next );

      BoardEval[ Next ] = Evalu();

      for( j = 0; j < Level; j++ ) {
        TmpRetCode = FindAllNol( 0, Next, 0, j + 2 );

        if( TmpRetCode == 1 ) {
          BoardEval[ Next ] = BoardEval[ Next ] + 5;
        }

        if( TmpRetCode == -1 ) {
          BoardEval[ Next ] = BoardEval[ Next ] - 5;
        }
      }

      DelCross( Next );
    }
    else {
      BoardEval[ Next ] = -10000;
    }
  }

  MaxVal = -200;
  BestMove = -1;

  for( i = 0; i < 64; i++ ) {
    if( Board[ i ] == EMPTY ) {
      if( MaxVal < BoardEval[ i ] ) {
        MaxVal = BoardEval[ i ];
        BestMove = i;
      }
    }
  }

  return( BestMove );
}
