/***************************************************************************
                          ticboard.h  -  description
                             -------------------
    begin                : Sun Apr 23 2000
    copyright            : (C) 2000 by Andrei Plekhanov
    email                : andyp@newtech.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TICBOARD_H
#define TICBOARD_H


/**
  *@author Andrei Plekhanov
  */

class ticboard
{
  private:

    int             Board[ 64 ];
    int             Line[ 76 ];

    void AddOne( int Move );

    void SubOne( int Move );

  public:

	  ticboard( void );

	  virtual ~ticboard( void );

    static const int CROSS =  1;
    static const int NOL   = -1;
    static const int EMPTY =  0;

    int GetBoard( int Pos ) const
      { return( Board[ Pos ] ); }

    int  Check( int Move, int type ) const;

    int  TestLine( int LineNumber ) const;

    int  CheckAllLines( int type ) const;

    void PutCross( int Move );

    void PutNol( int Move );

    void DelCross( int Move );

    void DelNol( int Move );

    int  CountPieces( void ) const;

    int  FindSpecCross( int TmpLine, int OldNol, int depth );

    int  FindCross( int OldCross, int OldNol, int depth );

    int  FindFastCross( int depth );

    int  FindSpecNol( int TmpLine, int OldCross, int depth );

    int  FindNol( int OldNol, int OldCross, int depth );

    int  FindFastNol( int depth );

    int  FindAllCross( int OldCross, int OldNol, int depth, int FastDepth );

    int  FindAllNol( int OldNol, int OldCross, int depth, int FastDepth );

    int  FindSpecCrossW( int TmpLine, int OldNol, int depth, int FastPCount, int * FastWinMove );

    int  FindCrossW( int OldCross, int OldNol, int depth, int FastPCount, int * FastWinMove );

    int  FindFastCrossW( int depth, int * FastWinMove );

    int  FindSpecNolW( int TmpLine, int OldCross, int depth );

    int  FindNolW( int OldNol, int OldCross, int depth );

    int  LineEval( int A1, int A2, int A3, int A4 ) const;

    int  Evalu( void ) const;

    int  GetComputerMove( int Level );
};

#endif
