/***************************************************************************
                          ttt3dgame.h  -  description
                             -------------------
    begin                : Thu Apr 27 2000
    copyright            : (C) 2000 by Andrei Plekhanov
    email                : andyp@newtech.ru
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TTT3DGAME_H
#define TTT3DGAME_H


/**
  *@author Andrei Plekhanov
  */

#include "ticboard.h"

class Ttt3dMove
{
  private:

    int Move;

    int Type;

  public:

    Ttt3dMove( int aMove, int aType )
      { Move = aMove; Type = aType; }

    int GetMove( void ) const
      { return( Move ); }

    int GetType( void ) const
      { return( Type ); }

    virtual ~Ttt3dMove( void ) {};
};

class Ttt3dGame : public ticboard
{
  private:

    int          Chain;
    int          Skill;
    int          Thinking;
    int          GameOver;
    int          First;
    int          WinMove[ 64 ];
    int          MoveNumber;
    Ttt3dMove ** History;

    void ClearWinMove( void );

    void DelHistory( void );

  public:

    static const int BEGINNER = 1;
    static const int NOVICE   = 2;
    static const int MASTER   = 3;

    static const int HUMAN_FIRST    = 0;
    static const int COMPUTER_FIRST = 1;

    static const int HUMAN_MOVE     = 0;
    static const int COMPUTER_MOVE  = 1;

    static const int CROSS_WIN     = 1;
    static const int NOL_WIN       = 2;
    static const int CONTINUE_PLAY = 3;
    static const int DRAW_GAME     = 4;
    static const int CROSS_ATTACK  = 5;
    static const int NOL_ATTACK    = 6;
    static const int CROSS_CHAIN   = 7;

	  Ttt3dGame( int aSkill = BEGINNER );

	  virtual ~Ttt3dGame( void );

    void SetHistory( int Move, int Type );

    int IfGameOver( void ) const
      { return( GameOver ); }

    int GetSkill( void ) const
      { return( Skill ); }

    int SetSkill( int aSkill );

    int IfThinking( void ) const
      { return( Thinking ); }

    int GetFirst( void ) const
      { return( First ); }

    const Ttt3dMove * GetHistoryMove( int Num ) const;

    int GetMoveNumber( void ) const
      { return( MoveNumber ); }

    int IfCross( int Pos ) const;

    int IfNol( int Pos ) const;

    int IfEmpty( int Pos ) const;

    int CheckDraw( void ) const;

    void RevertBoard( void );

    int ComputerMove( void );

    void UndoOneMove( void );

    int Undo( void );

    int WinLine( int Pos ) const;
};

#endif
